BASERUBY version policy

03/04/2020 06:40 AM - ko1 (Koichi Sasada)

Status: Closed   

Priority: Normal   

Assignee: hsbt (Hiroshi SHIBATA)   

Description

Ruby 2.7 (MRI) requires Ruby 2.2 or later (== BASERUBY) to build from repository.

Tarball does not need any installed Ruby.

To build latest Ruby from repository, you need to build Ruby 2.2 and later from a tarball.

Can we make the BASERUBY version update policy?

Background

To use ISeq#to_a (specific format) Ruby 2.2 or later is needed from Ruby 2.7.

The oldest version used by RubyCI machines was Ruby 2.2, so I determined update.

I needed to file a ticket about this version bump, sorry.

related: https://bugs.ruby-lang.org/issues/16668

Related issues:

Related to Ruby - Bug #16668: Syntax error in tool/vcs.rb Closed

Related to Ruby - Bug #16845: Building Ruby with system Ruby 1.8.7 results in... Closed

Associated revisions

Revision 1edef08ddadf0bd76122f830ef7953cda61c78aa - 01/20/2023 08:54 AM - hsbt (Hiroshi SHIBATA)

Added version policy of BASERUBY

[Misc #16671]

Revision 1edef08ddadf0bd76122f830ef7953cda61c78aa - 01/20/2023 08:54 AM - hsbt (Hiroshi SHIBATA)

Added version policy of BASERUBY

[Misc #16671]

Revision 1edef08d - 01/20/2023 08:54 AM - hsbt (Hiroshi SHIBATA)

Added version policy of BASERUBY

[Misc #16671]

Revision ac47b8df8f0a58d70eb35e95656d83da0c155aa0 - 03/11/2023 07:40 AM - k0kubun (Takashi Kokubun)

Bump the required BASERUBY version to 2.5 (#7504)

[Misc #16671]

I'd like to bump it to 2.7 to use pattern matching in

tool/mk_builtin_loader.rb.

However, I experienced a few blockers. 2.5 seems like the closest

version that is easy enough to use on CIs, so let me bump the version to

it as an intermediate step for it. I want to use &. and <<~ in 2.3 too.

Known blockers:

AppVeyor Visual Studio 2015 doesn't have Ruby 2.7. You'd need to bump

the version to Visual Studio 2019.

GitHub Actions windows-2019 doesn't have Ruby 2.7 either. You

can use ruby/setup-ruby, but configure doesn't seem to work with it.

For ruby/ruby-ci-imaage, bionic doesn't have Ruby 2.7. I tried using
ruby-build to build Ruby 2.7 from package, but the build on its CI

seems to somehow loop forever when I do that. So I gave it up for now.

We might want to wait until bionic becomes EOL.

Note:

AppVeyor Visual Studio 2015 has Ruby <= 2.6.3

https://www.appveyor.com/docs/windows-images-software/#ruby

GitHub Actions windows-2019 uses Ruby 2.5.9

https://github.com/actions/runner-images/blob/main/images/win/Windows2019-Readme.md
Bump the required BASERUBY version to 2.7 (#9566)

[Misc #16671]

Revision b4ed5b7dfe9ca01ef48922d1b2c154767b7e4e86 - 01/16/2024 11:54 PM - k0kubun (Takashi Kokubun)

Bump the required BASERUBY version to 2.7 (#9566)

[Misc #16671]

Revision b4ed5b7d - 01/16/2024 11:54 PM - k0kubun (Takashi Kokubun)

Bump the required BASERUBY version to 2.7 (#9566)

[Misc #16671]

History

#1 - 03/04/2020 06:46 AM - ko1 (Koichi Sasada)

- Related to Bug #16668: Syntax error in tool/vcs.rb added

#2 - 03/04/2020 08:24 AM - naruse (Yui NARUSE)

Through the discussion around CI, I reached a conclusion "Runtime environment and development environment are different".

Though CentOS and macOS bundles very old ruby, but it's no problem because they are just runtime environment.

If people want to develop Ruby master on those environment, they can install latest stable ruby with tarball.

Therefore BASERUBY can be a reasonable newer stable version.

It means newer than Ruby installed by default on for example CentOS.

#3 - 03/04/2020 09:47 AM - nobu (Nobuyoshi Nakada)

naruse (Yui NARUSE) wrote in #note-2:

Through the discussion around CI, I reached a conclusion "Runtime environment and development environment are different".

 Note that it is true for years, for instance, Windows 9x was supported as a runtime environment but not as a development environment, at least.

#4 - 03/05/2020 01:11 AM - shyouhei (Shyouhei Urabe)

I'm not against this issue but for record: commit 8a72c77c7920d129818b7b83bb4fa669cd7e3f7d says "as requested by devs, support for BASERUBY

prior to 2.1". and the "devs" here included ko1.  At that time his machine was a Panasonic laptop running Windows, and had older BASERUBY. 

Windows situation got improved since then (we now have CI).  This might no longer be a problem.

#5 - 05/09/2020 11:27 PM - hsbt (Hiroshi SHIBATA)

- Related to Bug #16845: Building Ruby with system Ruby 1.8.7 results in make failing due to syntax error in ./tool/lib/vcs.rb added

#6 - 09/26/2022 06:45 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Open to Assigned

- Assignee set to hsbt (Hiroshi SHIBATA)

#7 - 01/06/2023 04:48 AM - hsbt (Hiroshi SHIBATA)

How about the Ruby version provided by the stable Ubuntu release?

https://packages.ubuntu.com/search?keywords=ruby

bionic (18.04LTS): 2.5.1, standard EOL date is 2023/04

focal (20.04LTS): 2.7, standard EOL date is 2025/04

jammy (22.04LTS): 3.0, standard EOL date is 2027/04

So, we can upgrade the BASERUBY version of Ruby 3.3 to Ruby 2.7 in this year.

#8 - 01/06/2023 10:15 AM - nobu (Nobuyoshi Nakada)

What we often tend to write frequently are safe navigation operator and indented here-docs.

So I'll be happy it were 2.3 or later.

#9 - 01/20/2023 09:02 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Assigned to Closed
Applied in changeset git|1edef08ddadf0bd76122f830ef7953cda61c78aa.

Added version policy of BASERUBY

[Misc #16671]

#10 - 01/30/2023 02:12 AM - matz (Yukihiro Matsumoto)

I agree with upgrading BASERUBY. The version should be determined by the latest version of the distribution (Debian?).

Matz.

#11 - 01/30/2023 08:13 AM - vo.x (Vit Ondruch)

Why Ubuntu / Debian and not CentOS / RHEL 7? IOW I think it would be probably better to base the policy on Ruby releases then on external factor

such as Linux distribution versions.

#12 - 01/30/2023 08:27 AM - hsbt (Hiroshi SHIBATA)

CentOS 7 will be EOL at 2024/06 and CentOS 8+ will be not provided in the future.

I know Red Hat switched them to CentOS Stream. Unfortunately, CentOS Stream (and RHEL) is not major distribution for Ruby developers.
